
var $template = function () {
    var cache = {}, keyWords = {},
        keys = ('break,case,catch,continue,debugger,default,delete,do,else,false,finally,for,function,if'
            + ',in,instanceof,new,null,return,switch,this,throw,true,try,typeof,var,void,while,with'
            + ',abstract,boolean,byte,char,class,const,double,enum,export,extends,final,float,goto'
            + ',implements,import,int,interface,long,native,package,private,protected,public,short'
            + ',static,super,synchronized,throws,transient,volatile,arguments,let,yield').split(',');

    (function (keys) {
        var len = keys.length;
        while (len--) {
            //keyWords = {'yield': true, 'let': true, 'arguments': true......}
            keyWords[keys[len]] = true;
        }
    })(keys);

//是否是关键字
    var isKeyWords = function (val) {
        return keyWords[val];
    };

    var $ = function (id) {
        return document.getElementById(id);
    };

// 过滤XSS
    var xss = function (str) {
        var div = document.createElement("div"),
            text = document.createTextNode(str), val = '';

        div.appendChild(text);
        val = div.innerHTML.replace(/[\r\n]/g, '<br>');
        text = null;
        div = null;

        return val;
    };

//处理单/双引号互嵌的问题
    var handleStr = function (str) {
        //单引号替换为html的表示
        return str.replace(/'/g, '&apos;')
        //只将<% xxx %>外的单引号替换为html的表示
            .replace(/<%(.*?)%>/g, function (match) {
                return match.replace(/&apos;/g, "'");
            });
    };

    var template = function (str, data, context) {
        // 上下文环境
        context = context || window;

        // 如果传入的str是id
        if (/^[\w\-_]+$/.test(str)) {
            str = $(str).innerHTML;
        }

        str = str
        //单行和多行注释 PS: 有http://这样的
            .replace(/\/\*[\s\S]*?\*\/|[^:]\/\/.*?[\n\r\t]/g, "")
            //去回车、换行、制表
            .replace(/[\r\t\n]/g, " ");

        // 缓存
        if (cache[str]) {
            return data ? cache[str].call(context, data) : cache[str];
        }

        var variables = {}, declare = 'var ',
            //提取变量名：先提取所有的语句片段，再从中取得所有的变量名
            //ps：需要防止match方法没有匹配时--->null调用join会报错
            all_vars = (str.match(/<%(.*?)%>/g) || []).join(',').match(/[\_\$a-zA-Z]+[\_\$a-zA-Z0-9]*/g) || [];

        //去关键字去重，变量名是关键字的去掉
        (function (arr) {
            var len = arr.length, val = '';
            while (len--) {
                val = arr[len];
                if (val && !isKeyWords(val)) {
                    if (!variables.hasOwnProperty(val)) {
                        //declare = "var name=__data.name, age=__data.age, sex=__data.sex,
                        //variables = {'name': true, 'age': true, 'sex': true}
                        declare += (val + '= __data.' + val + ',');
                        variables[val] = true;
                    }
                }
            }
        })(all_vars);

        var tempStr = handleStr(str);

        var fn = cache[str] = new Function("__data",
            declare + "__s='', __xss=" + xss + ";" +
            "__s += '" + tempStr
                .replace(/(%>)[\s]*(<%)/g, "$1$2")
                .replace(/<%=(.*?)%>/g, "' + ($1) + '")
                .replace(/<%-(.*?)%>/g, "' + (__xss($1)) + '")
                .replace(/<%/g, "'\n")
                .replace(/%>/g, "\n__s += '")
            + "';return __s;");

        return data ? fn.call(context, data) : fn;

    };
    return template;
};
var template = $template();

$.fn.focusPic3 = function(options){
    var defaults = {
        at: 1000,
        t : 10000,
        n : 1,
        cName : 'curr',
        isFocus : false
    }
    var options = $.extend({}, defaults, options);
    var obj = new focusPic3(this,options);
    obj.init();
}

var _cacheIndex = 0,    //上一个图片
    _currIndex  = 0,    //当前第几张图片
    _imgNum     = 0,    //几组图片
    _timer      = 0,
    _$items     = null,
    _focus_selector     = '.focus-nav a:lt(5)';

function focusPic3(o,v){
    this.o = o;
    for(var i in v){
        this[i] = v[i];
    }
}

focusPic3.prototype = {
    init:function(){
        _$focus     = $(_focus_selector);
        _$items = $('li',$(this.o));
        _imgNum = Math.ceil(_$items.size()/this.n);
        _$items.eq(0).fadeIn(this.at);
        this.setFocusStyle();
        //this.createFocusBtnHtml();
        if(_imgNum>1){
            this.auto();
        }
        this.bindEvents();
    },
    bindEvents : function(){
        this.focusEvent();
    },
    //焦点事件
    focusEvent : function(){
        var self = this;
        $(this.o).on('click','.f-btn',function(){
            clearInterval(_timer);
            _prevIndex = _currIndex;
            if($(this).hasClass('next'))
                _currIndex = _currIndex >= _imgNum -1?0 : _currIndex + 1;
            else
                _currIndex = _currIndex <= 0? _imgNum -1 : _currIndex - 1;
            self.autoPlay();
            self.auto();
        });
        $(this.o).on('click', _focus_selector,function(){
            if(_currIndex == $(this).index())
                return;
            clearInterval(_timer);
            _prevIndex = _currIndex;
            _currIndex = $(this).index();
            self.autoPlay();
            self.auto();
        });
    },
    auto : function(){
        var self = this;
        _timer = setInterval(function(){
            _prevIndex = _currIndex;
            _currIndex  = _currIndex >= _imgNum -1?0 : _currIndex + 1;
            self.autoPlay();
        },this.t);
    },
    autoPlay : function(){
        var self = this;
        _$items.eq(_prevIndex).fadeOut(this.at);
        _$items.eq(_currIndex).fadeIn(self.at);
        this.setFocusStyle();
    },
    //设置焦点的样式
    setFocusStyle : function(){
        _$focus.eq(_currIndex).addClass(this.cName).siblings().removeClass(this.cName);
    }
}

$.customDate = function (options) {
    var defaults = {
        id: '',
        year: (new Date).getFullYear(),
        month: (new Date).getMonth() + 1,
        week: ['日', '一', '二', '三', '四', '五', '六'],
        currName: 'curr',
        selectedName: 'selected',
        onMonthChange: null,     //function(yearMonth,callback){},
        onMouseOver: null,     //function($o,day){},
        onMouseOut: null,
        onClickEvent: null     //function(callback){}
    };
    var options = $.extend({}, defaults, options);
    var obj = new customDate(this, options);
    obj.init();
    return obj;
}

function customDate(o, v) {
    this.o = o;
    for (var i in v) {
        this[i] = v[i];
    }
}

customDate.prototype = {
    init: function () {
        this.layout();
        this.monthData();
        this.bindEvents();
    },
    //生成日历html
    layout: function () {
        var html = [];
        html.push('<div class="pub-custom-date" style="height:344px;">');
        html.push('<div class="date-head" style="padding:10px 50px;">');
        html.push('<span class="prev-btn"><span class="icon-svg icon-svg-lg icon-svg-leftArrow"></span></span>');
        html.push('<span class="next-btn"><span class="icon-svg icon-svg-lg icon-svg-rightArrow"></span></span>');
        html.push('<span style="height:24px;line-height:24px;color:#fff;font-size:16px;text-align:center;display:block;">招聘日历</span>');
        html.push('<p class="curr-date" style="height:24px;line-height:24px;font-size:16px;"></p>');
        html.push('</div>');

        html.push('<div class="date-content">');
        html.push('<table class="date-table">');
        html.push('<thead class="date-thead">');
        html.push('<tr>');
        for (var i = 0; i < this.week.length; i++) {
            html.push('<th><span class="date-text">' + this.week[i] + '</span></th>');
        }
        html.push('</tr>');
        html.push('</thead>');
        html.push('</table>');

        html.push('<div class="date-days"></div>');
        html.push('</div>');
        html.push('</div>');
        $('#' + this.id).html(html.join(''));
    },
    //生成一个月的数据
    createDaysHtml: function () {
        var html = [],
            days = this.getMothDays(this.year, this.month),
            weekDay = this.getFirstDay(this.year, this.month - 1),
            prev_year,
            prev_month,
            prev_days,
            next_year,
            next_month,
            next_days;

        if (this.month == 1) {
            prev_month = 12;
            prev_year = this.year - 1;
            prev_days = this.getMothDays(prev_year, prev_month);
        } else {
            prev_month = this.month - 1;
            prev_year = this.year;
            prev_days = this.getMothDays(prev_year, prev_month);
        }
        if (this.month == 12) {
            next_month = 1;
            next_year = this.year + 1;
            next_days = this.getMothDays(next_year, next_month);
        } else {
            next_month = this.month + 1;
            next_year = this.year;
            next_days = this.getMothDays(next_year, next_month);
        }
        var prev_first_day = prev_days - weekDay,
            next_day = 1;
        html.push('<table class="date-table">');
        html.push('<tbody class="date-tbody">');
        for (var a = 0, b = 0; a < 42; a++) {
            if (a % 7 == 0) {
                html.push('<tr>');
            }
            if (a < weekDay) {
                var currDay = prev_year + '-' + prev_month + '-' + (++prev_first_day);
                html.push('<td class="date-cell prev-cell" data-year="' + prev_year + '"  data-month="' + (prev_year + '-' + prev_month) + '"  data-day="' + currDay + '">');
                html.push('<span class="date-text">' + prev_first_day + '</span>');
                html.push('</td>');
            } else if (a >= weekDay + days) {
                var currDay = next_year + '-' + next_month + '-' + next_day;
                html.push('<td class="date-cell next-cell" data-year="' + next_year + '"  data-month="' + (next_year + '-' + next_month) + '"  data-day="' + currDay + '">');
                html.push('<span class="date-text">' + (next_day++) + '</span>');
                html.push('</td>');
            } else {
                var currDay = this.year + '-' + this.month + '-' + (b + 1);
                html.push('<td class="date-cell" data-year="' + this.year + '"  data-month="' + (this.year + '-' + this.month) + '"  data-day="' + currDay + '">');
                // 改为正常显示的日期，添加背景色
                if (currDay === this.getCurrDay()) {
                    html.push('<span class="date-text date-today">' + (++b) + '</span>');
                    // html.push('<span class="date-text">今</span>');
                    // ++b;
                } else {
                    html.push('<span class="date-text">' + (++b) + '</span>');
                }
                html.push('</td>');
            }
            if ((a + 1) % 7 == 0) {
                html.push('</tr>');
            }
        }
        html.push('</tbody>');
        html.push('</table>');
        $('#' + this.id).find('.date-days').html(html.join(''));
        this.setTodayStyle();
    },
    createDateTips: function (top, left) {
        var html = [];
        html.push('<div class="pub-date-tips">');
        html.push('<div class="dt-inner">');
        html.push('</div>');
        html.push('</div>');
        $('body').append(html.join(''));
        var $dataTips = $('.pub-date-tips');
        this.setDateTipsStyle($dataTips, top, left);
    },
    setDateTipsStyle: function ($dataTips, top, left) {
        $dataTips.css({
            top: top,
            left: left
        });
    },
    //设置今天的样式
    setTodayStyle: function () {
        var fontColor = $('.pub-custom-date .date-head').css('background-color');
        $('.date-today').text('今').css({
            'color': fontColor,
            'border': '1px solid ' + fontColor,
            'border-radius': '50%'
        });
    },
    /*
     * 获取当前月份天数
     */
    getMothDays: function (year, month) {
        var date = new Date(year, month, 0);
        return date.getDate();
    },
    /*
     * 获取月份第一天
     */
    getFirstDay: function (year, month) {
        var date = new Date(),
            newDate = new Date(year, month, 1);
        return newDate.getDay();
    },
    bindEvents: function () {
        this.prevEvent();
        this.nextEvent();
        this.clickEvent();
    },
    setTit: function () {
        var $tit = $('#' + this.id).find('.curr-date');
        $tit.text(this.year + '年' + this.month + '月');
    },
    //获取当前日期
    getCurrDay: function () {
        var date = new Date(),
            year = date.getFullYear(),
            month = parseInt(date.getMonth()) + 1,
            date = date.getDate();
        return year + '-' + month + '-' + date;
    },
    //设置当前日期的样式
    setCurrdateStyle: function (day) {
        var currDate = day;
        var $currDate = $('#' + this.id).find('.date-cell[data-day="' + currDate + '"]');
        $currDate.addClass('curr').siblings().removeClass('curr');
        $currDate.closest('tr').siblings().find('.date-cell').removeClass('curr');
    },
    //设置可预定的日期
    setDates: function (data) {
        var self = this;
        var $dateDays = $('#' + this.id).find('.date-cell[data-day]');
        for (var i = 0; i < data.length; i++) {
            $.each($dateDays, function (a, el) {
                var item = data[i];
                if ($(el).attr('data-day') == item.book_day) {
                    $(el).addClass(self.selectedName);
                    switch (item.type) {
                        case '0':
                            $(el).addClass('career');
                            break;
                        case '1':
                            $(el).addClass('jobfair');
                            break;
                    }
                }
            });
        }
    },
    hoverEvent: function () {
        if (!this.onMouseOver) return;
        var self = this,
            $selectedDays = $('#' + this.id).find('.date-cell.' + this.selectedName),
            timer;
        if ($selectedDays.length) {
            $selectedDays.hover(function () {
                clearTimeout(timer);
                var $dateText = $(this).find('.date-text'),
                    top = $dateText.offset().top + Math.ceil($dateText.outerHeight() / 2) - 15,
                    left = $dateText.offset().left + Math.ceil($dateText.outerWidth() + 15),
                    day = $(this).attr('data-day');
                var $dateTips = $('.pub-date-tips');
                if ($dateTips.length > 0) {
                    self.setDateTipsStyle($dateTips, top, left);
                } else {
                    self.createDateTips(top, left);
                }
                var $dateTipsInner = $('.pub-date-tips').find('.dt-inner');
                self.onMouseOver($dateTipsInner, day);
            }, function () {
                timer = setTimeout(function () {
                    self.removeDayTips();
                }, 400);
                var $dateTips = $('.pub-date-tips');
                if ($dateTips.length) {
                    $dateTips.hover(function () {
                        clearTimeout(timer);
                        $('.section-wrap').stop().css('bottom','140px');
                    }, function () {
                        self.removeDayTips();
                    });
                }
            });
        }
    },
    clickEvent: function () {
        if (!!this.onClickEvent) {
            var self = this;
            $('#' + this.id).on('click', '.date-tbody .date-cell', function () {
                if (!$(this).hasClass('curr')) {
                    var day = $(this).attr('data-day');
                    if (!!day) {
                        self.setCurrdateStyle(day);
                        self.onClickEvent(day);
                    }
                }
            });
        }
    },
    //移除tips
    removeDayTips: function () {
        var $dayTips = $('.pub-date-tips');
        if ($dayTips.length) {
            $dayTips.remove();
        }
    },
    //一个月的数据
    monthData: function () {
        var self = this;
        if (!!this.onMonthChange) {
            var yearMonth = self.year + '-' + self.month;
            this.onMonthChange(yearMonth, function (data) {
                self.setTit();
                self.createDaysHtml();
                self.setDates(data);
                self.hoverEvent();
            });
        }
    },
    //上一个月
    prevEvent: function () {
        var self = this;
        $('#' + this.id).on('click', '.prev-btn', function () {
            if (self.month > 1) {
                self.month = self.month - 1;
            } else {
                self.month = 12;
                self.year = self.year - 1;
            }
            self.monthData();
        });
    },
    //下一个月
    nextEvent: function () {
        var self = this;
        $('#' + this.id).on('click', '.next-btn', function () {
            if (self.month >= 12) {
                self.month = 1;
                self.year = self.year + 1;
            } else {
                self.month = self.month + 1;
            }
            self.monthData();
        });
    }
}

var date_temp = '<% var record = list %>\n' +
    '        <% if(record.length){ %>\n' +
    '        <ul class="date-text-list">\n' +
    '            <% for(var i = 0;i<record.length;i++){ %>\n' +
    '            <% var item = record[i]; %>\n' +
    '            <li class="item" data-id="<%- item.career_talk_id?item.career_talk_id:item.fair_id %>">\n' +
    '                <p class="item-text">\n' +
    '                    <a href="'+__host+'/detail/<%- item.career_talk_id?\'career\':\'jobfair\' %>?id=<%- item.career_talk_id?item.career_talk_id:item.fair_id %>" class="item-link has-dot" target="_blank" title="<%- item.fair_id?item.school_name:item.meet_name %>&nbsp;&nbsp;<%- item.address %>">\n' +
    '                        <%- item.fair_id?\'【双选】\'+item.title:(item.career_state==1?\'【宣讲取消】\':\'【宣讲】\')+item.meet_name %>\n' +
    '                        &nbsp;&nbsp;\n' +
    '                        <%- item.fair_id?\'\':item.address %>\n' +
    '                    </a>\n' +
    '                </p>\n' +
    '                <span class="item-time"><%- item.fair_id?item.begin_time:item.meet_time %></span>\n' +
    '            </li>\n' +
    '            <% } %>\n' +
    '        </ul>\n' +
    '        <% } %>';

var ns = {
    init: function () {
        this.bindEvents();
    },

    bindEvents: function () {
        this.bindDateEvent();
    },
    bindDateEvent: function () {
        var self = this;
        $.customDate({
            id: 'side_date',
            onMonthChange: function (yearMonth, callback) {
                callback([]);
                //_dialog.innerLoading($('#'+this.id).find('.date-days'));
                $.getJSON(__host + "/api/getcareerdays?year_month=" + yearMonth + "&jsoncallback=?",
                    function (data) {
                        callback(data);
                    }
                );
            },
            onMouseOver: function ($o, day) {
                if (!!window[day]) {
                    self.bindDateTipsData($o, window[day]);
                    return;
                }
                $.getJSON(__host + "/api/getdaycareers?day=" + day + "&jsoncallback=?",
                    function (data) {
                        window[day] = data;
                        self.bindDateTipsData($o, data);
                    }
                );
            }
        });
    },
    /*
     * 绑定日历tips
     * @params data array
     */
    bindDateTipsData: function ($o, data) {
        if (!data || data.length <= 0) return;

        var dataSet = {
            list: data
        };
        var html = template(date_temp, dataSet);
        $o.html(html);
    },
};
ns.init();